/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package plugins;

import com.google.gdata.client.Query;
import com.google.gdata.client.photos.PicasawebService;
import com.google.gdata.data.photos.AlbumFeed;
import com.google.gdata.data.photos.PhotoEntry;
import com.google.gdata.util.ServiceException;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import project.pluginInterface;
import tools.ObjectResult;

/**
 *
 * @author Ludovic
 */
public class pluginPicasa implements pluginInterface {

    private int countResult = 0;
    private ArrayList<ObjectResult> resultList;
    private String type = "Photo";

    public boolean loadPlugin() {
        return true;
    }

    public String getType() {
        return type;
    }

    public ArrayList<ObjectResult> search(String query, int n, int m) {

        try {
            resultList = new ArrayList<ObjectResult>();
            
            
            PicasawebService myService = new PicasawebService("exampleCo-exampleApp-1");
//myService.setUserCredentials("liz@gmail.com", "mypassword");
            URL baseSearchUrl = new URL("http://picasaweb.google.com/data/feed/api/all");
            Query myQuery = new Query(baseSearchUrl);
            myQuery.setStringCustomParameter("kind", "photo");
            myQuery.setStartIndex(m);
            myQuery.setMaxResults(n);
            myQuery.setFullTextQuery(query);
            AlbumFeed searchResultsFeed = myService.query(myQuery, AlbumFeed.class);
            for (PhotoEntry photo : searchResultsFeed.getPhotoEntries()) {

                String titre = photo.getTitle().getPlainText().replaceAll("\"", "&quot;").replaceAll("'", "&acute;");
                String desc = photo.getDescription().getPlainText().replaceAll("\"", "&quot;").replaceAll("'", "&acute;");
                
                ObjectResult ob = new ObjectResult();
                ob.getDetailList().put("Titre", titre);
                ob.getDetailList().put("Type", type);
                ob.getDetailList().put("Description", desc);
                ob.getDetailList().put("Camera Model", photo.getExifTags().getCameraModel());

                ob.setThumbURL("<IMG SRC=\""+ photo.getMediaThumbnails().get(1).getUrl() + "\">");
                ob.setPreviewHTMLSource("<IMG SRC =\"" + photo.getMediaThumbnails().get(2).getUrl() + "\">");

                resultList.add(ob);

            }
    

        } catch (IOException ex) {
            Logger.getLogger(pluginPicasa.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ServiceException ex) {
            Logger.getLogger(pluginPicasa.class.getName()).log(Level.SEVERE, null, ex);
        } 

        return resultList;


    }

    public String getLogoURL() {
        return "http://externaute.net/wp-content/uploads/picasa_logo.gif";
    }

    public int getCountResult() {
        return 1;
    }

    public String getPreJS() {
        return null;
    }

    public String getPostJS() {
        return null;
    }

    public HashMap<String, String> getFileToLoad() {
        return null;
    }

}
