/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package plugins;

import com.google.gdata.client.youtube.YouTubeQuery;
import com.google.gdata.client.youtube.YouTubeService;
import com.google.gdata.data.media.mediarss.MediaThumbnail;
import com.google.gdata.data.youtube.VideoEntry;
import com.google.gdata.data.youtube.VideoFeed;
import com.google.gdata.data.youtube.YouTubeMediaGroup;
import com.google.gdata.util.ServiceException;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import project.pluginInterface;
import tools.ObjectResult;

/**
 *
 * @author Ludovic
 */
public class pluginYoutube implements pluginInterface {

    public static final String YOUTUBE_GDATA_SERVER =
            "http://gdata.youtube.com";
    // The URL of the "Videos" feed
    public static final String VIDEOS_FEED =
            YOUTUBE_GDATA_SERVER + "/feeds/api/videos";
    // The URL of the "Standard" feed
    public static final String STANDARD_FEED =
            YOUTUBE_GDATA_SERVER + "/feeds/api/standardfeeds/";
    private int countResult = 0;
    private ArrayList<ObjectResult> resultList;

    private String type = "Video";

    public boolean loadPlugin() {
        return true;
    }

    public ArrayList<ObjectResult> search(String _query, int n, int m) {

        try {
            resultList = new ArrayList<ObjectResult>();
            YouTubeService service = new YouTubeService("gdataSample-YouTube-2");
            YouTubeQuery query = new YouTubeQuery(new URL(VIDEOS_FEED));
            query.setOrderBy(YouTubeQuery.OrderBy.RATING);

            query.setStartIndex(m);
            query.setMaxResults(n);
            query.setFullTextQuery(_query);

            VideoFeed videoFeed = service.query(query, VideoFeed.class);


            if (videoFeed.getPreviousLink() != null) {
                VideoFeed previousVideoFeed = service.getFeed(new URL(videoFeed.getPreviousLink().getHref()), VideoFeed.class);
            }

            if (videoFeed.getNextLink() != null) {
                VideoFeed nextVideoFeed = service.getFeed(new URL(videoFeed.getNextLink().getHref()), VideoFeed.class);
            }
            if (videoFeed != null) {
                countResult = videoFeed.getTotalResults();

                for (VideoEntry ve : videoFeed.getEntries()) {
                    YouTubeMediaGroup mediaGroup = ve.getMediaGroup();
                    if (mediaGroup != null) {
                        String titre = ve.getTitle().getPlainText();
                        List<MediaThumbnail> thumbs = mediaGroup.getThumbnails();
                        ve.getEtag();
                        titre = titre.replaceAll("\"", "&quot;").replaceAll("'", "&acute;");

                        ObjectResult ob = new ObjectResult();
                        ob.getDetailList().put("Type", type);
                        ob.getDetailList().put("Titre", titre);
                        ob.getDetailList().put("Durée", ve.getMediaGroup().getDuration() / 60 + ":" + String.format("%02d", ve.getMediaGroup().getDuration() % 60));
                        ob.getDetailList().put("Uploader", ve.getMediaGroup().getUploader());
                        ob.getDetailList().put("Average Rating", String.valueOf(ve.getRating().getAverage()));
                        ob.getDetailList().put("View count", String.valueOf(ve.getStatistics().getViewCount()));

                        ob.setThumbURL("<IMG SRC=\""+thumbs.get(0).getUrl() +"\">");
                        ob.setPreviewHTMLSource("<object width=\"425\" height=\"355\"><param name=\"movie\" value=\"http://www.youtube.com/v/" + ve.getMediaGroup().getVideoId() + "&hl=en\"></param><param name=\"wmode\" value=\"transparent\"></param><embed src=\"http://www.youtube.com/v/" + ve.getMediaGroup().getVideoId() + "&hl=en\" type=\"application/x-shockwave-flash\" wmode=\"transparent\" width=\"425\" height=\"355\"></embed></object>");                        
                        resultList.add(ob);

                    }
                }
            }
        } catch (IOException ex) {
            Logger.getLogger(pluginYoutube.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ServiceException ex) {
            Logger.getLogger(pluginYoutube.class.getName()).log(Level.SEVERE, null, ex);
        }

        return resultList;
    }

    public String getLogoURL() {
        //TODO write your implementation code here:
        return "http://blogmotion.fr/wp-content/uploads/2008/05/youtube-logo.png";
    }

    public int getCountResult() {
        //TODO write your implementation code here:
        return countResult;
    }

    public String getType() {
       return type;
    }

    public String getPreJS() {
        return null;
    }

    public String getPostJS() {
        return null;
    }

    public HashMap<String, String> getFileToLoad() {
        return null;
    }
}
