package project;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import com.google.gson.Gson;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import tools.Introspection;
import tools.Module;
import tools.ObjectResult;

/**
 *
 * @author Ludovic
 */
public class Search extends HttpServlet {

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {

            String searchTerms = request.getParameter("query");
            int nbrResult = Integer.parseInt(request.getParameter("n"));
            int indexResult = Integer.parseInt(request.getParameter("m"));


            Class[] c = Introspection.getClasses("plugins");
            ArrayList<Module> listMods = new ArrayList<Module>();

            for (int i = 0; i < c.length; i++) {
                pluginInterface plug = (pluginInterface) c[i].newInstance();

                boolean loadPlugin = plug.loadPlugin();

                if (loadPlugin) {
                    ArrayList<ObjectResult> ret = plug.search(searchTerms, nbrResult, indexResult);
                    if (ret != null) {
                        Module mod = new Module();
                        mod.setListObjet(ret);
                        mod.setLogoURL(plug.getLogoURL());
                        mod.setCountResult(plug.getCountResult());
                        mod.setType(plug.getType());
                        mod.setPostJS(plug.getPostJS());
                        mod.setPreJS(plug.getPreJS());
                        mod.setFileToLoad(plug.getFileToLoad());
                        listMods.add(mod);
                    }
                }
            }


            out.write(new Gson().toJson(listMods));



        } catch (Exception ex) {
            Logger.getLogger(Search.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            out.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
